SystemOrganization addCategory: #OldChat!


Object subclass: #OldChat
	instanceVariableNames: 'isRunning listener '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OldChat'!

Object subclass: #OldChatAgent
	instanceVariableNames: 'stream bindings history isRunning '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OldChat'!

OldChat class
	instanceVariableNames: ''!

OldChatAgent class
	instanceVariableNames: ''!


!OldChat commentStamp: 'tak 5/2/2004 17:14' prior: 0!
OldChat - a simple Squeak remote controller

OldChat services explore.
OldChat new start inspect.

$ telnet localhost 4919

or try with emacs
(defun squeak ()
  (interactive)
  (make-comint "squeak" '("localhost" . 4919))
  (pop-to-buffer "*squeak*"))

SARPackageDumper fileOutPackage: (PackageInfo named: 'OldChat') as: 'OldChat.sar'


!

!Behavior methodsFor: '*oldChat' stamp: 'tak 5/2/2004 01:55'!
>>> aSymbol
	^ self sourceCodeAt: aSymbol! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:46'!
at: index
	^ history at: index! !

!OldChatAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 14:23'!
back
	history size > 1
		ifTrue: [history removeLast].
	^ history last.! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 03:39'!
bannerString
	^ '** Welcome to Squeak
** VM: ' , Smalltalk platformName asString , '
**  - ' , Smalltalk vmVersion asString , '
** Image: ' , Smalltalk version asString , ' [' , Smalltalk lastUpdateString asString , ']'! !

!OldChatAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 13:22'!
bindingOf: aString 
	^ (self pseudoVars includes: aString)
		ifTrue: [aString -> (self perform: aString asSymbol)]
		ifFalse: [(bindings includesKey: aString)
				ifFalse: [bindings at: aString put: nil].
			bindings associationAt: aString]! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:40'!
bindings
	^ bindings! !

!Inspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:23'!
briefDumpOn: aStream 
	aStream nextPutAll: object defaultLabelForInspector;
		 cr.
	aStream nextPutAll: '====================';
		 cr.
	self fieldListForPrint
		keysAndValuesDo: [:index :value | 
			aStream nextPutAll: value , ' :'.
			aStream tab.
			aStream
				nextPutAll: ((self contentsAt: index)
						printStringLimitedTo: 80).
			aStream cr]! !

!DictionaryInspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:05'!
contentsAt: index
	^ object at: (keyArray at: index)
! !

!Inspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:03'!
contentsAt: index 
	^ object instVarAt: index! !

!OrderedCollectionInspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:22'!
contentsAt: index 
	^ object at: index! !

!OldChat methodsFor: 'accessing' stamp: 'tak 5/2/2004 10:13'!
defaultPort
	^ 4919! !

!OldChatAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 17:16'!
exit
	isRunning _ false.
	self show: 'bye!!'! !

!DictionaryInspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:02'!
fieldListForPrint
	^ self fieldList
! !

!Inspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 15:54'!
fieldListForPrint
	^ self fieldList allButFirst: 2
! !

!OrderedCollectionInspector methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:21'!
fieldListForPrint
	^ (1 to: object size) collect: [:each | each asString]
! !

!ClassDescription methodsFor: '*oldChat' stamp: 'tak 5/2/2004 03:16'!
fileOutString
	^String streamContents: [ :aStream |
		self fileOutOn: aStream]! !

!OldChat methodsFor: 'private' stamp: 'tak 5/2/2004 17:00'!
handle: socket 
	| aStream |
	[aStream _ SocketStream on: socket.
	(OldChatAgent on: aStream) readEvalPrint]
		ensure: [aStream close]! !

!OldChatAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 17:43'!
help
	^ self show: self bannerString, '
--
Useful expression and pseudo variables.

help -- This message.
exit  -- Exit.
self -- Current object.
ii -- Inspect self.
history -- Show history.
back -- Back.

q -- The agent (me).
q at: index -- Get an object in history.
q bindings  -- Local variables.
q stream  -- input/output stream.
'! !

!OldChatAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 16:45'!
history
	| indexes |
	indexes _ 1 to: history size.
	(indexes size < 10
		ifTrue: [indexes]
		ifFalse: [indexes last: 10])
		do: [:index | self show: index asString , ': '
					, ((history at: index)
							printStringLimitedTo: 80)].
! !

!OldChatAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 17:04'!
ii
	self show: self object inspectPrint! !

!OldChatAgent methodsFor: 'initialize' stamp: 'tak 5/2/2004 13:41'!
initialize
	history _ OrderedCollection new.
	bindings _ Dictionary new.
	history addLast: self.! !

!Object methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:35'!
inspectPrint
	^ Inspector inspectPrint: self! !

!Inspector class methodsFor: '*oldChat' stamp: 'tak 5/2/2004 16:36'!
inspectPrint: anObject 
	| inspector |
	inspector _ ((anObject isKindOf: Dictionary)
				ifTrue: [DictionaryInspector]
				ifFalse: [(anObject isKindOf: OrderedCollection)
						ifTrue: [OrderedCollectionInspector]
						ifFalse: [Inspector]]) new.
	inspector inspect: anObject.
	^ String
		streamContents: [:aStream | inspector briefDumpOn: aStream]! !

!OldChat methodsFor: 'accessing' stamp: 'tak 5/2/2004 09:57'!
isRunning
	^ isRunning
		and: [listener notNil
				and: [listener isWaitingForConnection]]! !

!OldChat methodsFor: 'private' stamp: 'tak 5/2/2004 10:19'!
listenLoop
	| socket |
	[self isRunning]
		whileTrue: [[socket _ listener waitForAcceptFor: 600.
			socket isConnected
				ifTrue: [[self handle: socket] fork]]
				on: ConnectionTimedOut
				do: ["nothing"
					]]! !

!OldChatAgent class methodsFor: 'instance creation' stamp: 'tak 5/2/2004 13:22'!
new
	^ super new initialize! !

!OldChat methodsFor: 'private' stamp: 'tak 5/2/2004 10:17'!
newListenerOn: portNumber
	listener _ Socket newTCP.
	listener listenOn: portNumber backlogSize: 10.
	^ listener! !

!OldChatAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
notify: aString at: anInteger in: aStream 
! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 14:35'!
object
	^ history last! !

!OldChatAgent class methodsFor: 'instance creation' stamp: 'tak 5/2/2004 00:33'!
on: aSocketStream
	^ self new stream: aSocketStream! !

!OldChat methodsFor: 'printing' stamp: 'tak 5/2/2004 12:15'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' [' , self statusString , ']'! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:52'!
printOn: aStream
	aStream nextPutAll: 'Mr.Q'! !

!OldChatAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 17:06'!
pseudoVars
	^ #(#help #ii #q #back #history #exit )! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 14:25'!
push: anObject 
	(history last == anObject
			or: [anObject == history
					or: [anObject == self
							or: [anObject isNil]]])
		ifFalse: [history addLast: anObject]! !

!OldChatAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 14:16'!
q
	^ self! !

!OldChatAgent methodsFor: 'eval loop' stamp: 'tak 5/2/2004 16:53'!
readEvalPrint
	| line answer |
	isRunning _ true.
	self show: self bannerString.
	[isRunning]
		whileTrue: [line _ self request: '> '.
			line
				ifNotNil: [answer _ [Compiler
								evaluate: line
								for: self object
								notifying: self
								logged: false]
								on: Error
								do: [:ex | ex].
					self show: answer.
					self push: answer]]! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 13:36'!
request: prompt 
	| line |
	line _ nil.
	stream nextPutAll: prompt;
		 flush.
	[[line isNil]
		whileTrue: [line _ [stream nextLine]
						on: ConnectionTimedOut
						do: [:ex | 
							'nothing'.
							nil]].
	^ line]
		on: Error
		do: [:ex | (ex class = ConnectionClosed
					or: [ex messageText = 'a primitive has hailed'])
				ifFalse: [ex signal]].
	^ self exit! !

!OldChatAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
select
	"hack"
	^ Error signal! !

!OldChatAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
selectFrom: start to: stop
	"hack"! !

!OldChatAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
selectionInterval
	"hack"
	^ 0 to: 0! !

!OldChat class methodsFor: 'accessing' stamp: 'tak 5/2/2004 12:08'!
services
	"self services inspect"
	^ self allInstances select: [:each | each isRunning]! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 15:24'!
show: anObject 
	| source next |
	source _ (anObject isText
				ifTrue: [anObject string]
				ifFalse: [anObject isString
						ifTrue: [anObject]
						ifFalse: [anObject isNumber
								ifTrue: [anObject asString]
								ifFalse: [anObject printString]]]) convertToSystemString readStream.
	[source atEnd]
		whileFalse: [next _ source next.
			next = Character cr
				ifTrue: [stream nextPutAll: String crlf]
				ifFalse: [stream nextPut: next]].
	stream nextPutAll: String crlf.
	stream flush! !

!OldChat methodsFor: 'actions' stamp: 'tak 5/2/2004 10:20'!
start
	self startOn: self defaultPort! !

!OldChat methodsFor: 'actions' stamp: 'tak 5/2/2004 10:19'!
startOn: portNumber 
	isRunning _ true.
	listener _ self newListenerOn: portNumber.
	[[self listenLoop]
		ensure: [listener
				ifNotNil: [listener closeAndDestroy]]] fork! !

!OldChat methodsFor: 'accessing' stamp: 'tak 5/2/2004 09:53'!
statusString
	^ isRunning
		ifTrue: [listener
				ifNotNil: [listener statusString]]
		ifFalse: ['stop']! !

!OldChat methodsFor: 'actions' stamp: 'tak 5/1/2004 21:27'!
stop
	isRunning _ false! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 14:19'!
stream
	^ stream! !

!OldChatAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 00:30'!
stream: aSocketStream
	stream _ aSocketStream! !

!OldChatAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
text
	^ '' asText! !
